<?php
	//Code for Session Cookie workaround
	if (isset($_POST["PHPSESSID"])) 
	{
		session_id($_POST["PHPSESSID"]);
	} else if (isset($_GET["PHPSESSID"]))
	{
		session_id($_GET["PHPSESSID"]);
	}
	session_start();
	//Check post_max_size (http://us3.php.net/manual/en/features.file-upload.php#73762)
	$POST_MAX_SIZE = ini_get('post_max_size');
	$unit = strtoupper(substr($POST_MAX_SIZE, -1));
	$multiplier = ($unit == 'M' ? 1048576 : ($unit == 'K' ? 1024 : ($unit == 'G' ? 1073741824 : 1)));

	if ((int)$_SERVER['CONTENT_LENGTH'] > $multiplier*(int)$POST_MAX_SIZE && $POST_MAX_SIZE) 
	{
		_handleUploadError("POST exceeded maximum allowed size.");
		exit();
	}
	//Settings
	$upload_name = "Filedata";
	$imageSizeMaxPX = 1300;
	$imageResizeToPX = 1250;
	$max_file_size_in_bytes = 2147483647; // 2GB in bytes
	$extension_whitelist = array("jpg", "jpeg", "gif", "png"); // Allowed file extensions
	$valid_chars_regex = '.A-Z0-9_ !@#$%^&()+={}\[\]\',~`-'; // Characters allowed in the file name (in a Regular Expression format)
	//Other variables	
	$MAX_FILENAME_LENGTH = 260;
	$uploadErrors = array
	(
        0=>"There is no error, the file uploaded with success",
        1=>"The uploaded file exceeds the upload_max_filesize directive in php.ini",
        2=>"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
        3=>"The uploaded file was only partially uploaded",
        4=>"No file was uploaded",
        6=>"Missing a temporary folder"
	);
	//Validate the upload
	if (!isset($_FILES[$upload_name]))
	{
		_handleUploadError("No upload found in \$_FILES for " . $upload_name);
		exit();
	} else if (isset($_FILES[$upload_name]["error"]) && $_FILES[$upload_name]["error"] != 0)
	{
		_handleUploadError($uploadErrors[$_FILES[$upload_name]["error"]]);
		exit();
	} else if (!isset($_FILES[$upload_name]["tmp_name"]) || !@is_uploaded_file($_FILES[$upload_name]["tmp_name"]))
	{
		_handleUploadError("Upload failed is_uploaded_file test.");
		exit();
	} else if (!isset($_FILES[$upload_name]['name']))
	{
		_handleUploadError("File has no name.");
		exit();
	}
	//Validate file extension
	$path_info = pathinfo($_FILES[$upload_name]['name']);
	$file_extension = $path_info["extension"];
	$is_valid_extension = false;
	foreach ($extension_whitelist as $extension)
	{
		if (strcasecmp($file_extension, $extension) == 0)
		{
			$is_valid_extension = true;
			break;
		}
	}
	if (!$is_valid_extension)
	{
		_handleUploadError("Invalid file extension");
		exit();
	}
	//Validate file contents (extension and mime-type can't be trusted)
	if(!@getimagesize($_FILES[$upload_name]["tmp_name"]))
	{
		_handleUploadError("Uploaded file is not an image or is corrupted. Please provide valid image.");
		exit();
	}
	//move the file
	$dataDir = rawurldecode($_POST["saveDir"]);
	$i = 0;
	$tmpName = 'tmp' . $i . '.' . $file_extension;
	while (file_exists($dataDir . $tmpName))
	{
		$i++;
		$tmpName = 'tmp' . $i . '.' . $file_extension;
	}
	$filePath = $dataDir . $tmpName;
	if (!@move_uploaded_file($_FILES[$upload_name]["tmp_name"], $filePath))
	{
		_handleUploadError("File could not be saved." . $filePath);
		exit();
	}
	list($w, $h) = getimagesize($filePath);
	if($w > $imageSizeMaxPX || $h > $imageSizeMaxPX)
	{
		_resizeImage ($filePath, $imageResizeToPX);
	}
	//Return output to the browser
	$name = addslashes($_FILES[$upload_name]['name']);
	$data = '{stat: "ok", name: "' . $name . '", path: "' . addslashes($filePath) . '"}';
	if(isset($_POST["is_simple"]))
	{
		echo '<script type="text/javascript">parent.GalleryIns.AddPage.C_uploadSimpleResponse('.$data.')</script>';
	}
	else
	{
		echo $data;
	}
	/*
	 * Handles the file upload error output.
	 * 
	 * @author Denis Zenkovich <denis.zenkovich@picturesurf.org>
	 */
	function _handleUploadError ($message) 
	{
		$data = '{stat: "fail", message: "'.addslashes($message).'"}';
		if(isset($_POST["is_simple"]))
		{
			echo '<script type="text/javascript">parent.GalleryIns.AddPage.C_uploadSimpleResponse('.$data.')</script>';
		}
		else 
		{
			echo $data;
		}
	}
	/*
	 * Handles the image resize if it's enourmously large
	 * 
	 * @author Denis Zenkovich <denis.zenkovich@picturesurf.org>
	 */
	function _resizeImage ($file, $max)
	{
		if(!function_exists('imagecopyresampled') || !function_exists('imagecreatefromjpeg') || !function_exists('imagecreatefromgif'))
		{
			return;
		}
		list($w, $h, $type) = getimagesize($file);
		if($type == 1)
		{
			$img = imagecreatefromgif($file);
		} elseif ($type == 2)
		{
			$img = imagecreatefromjpeg($file);
		} elseif ($type == 3)
		{
			$img = imagecreatefrompng($file);
		}
		$scale = $max/max($w, $h);
		$nw = round($w*$scale);
		$nh = round($h*$scale);
		$nimg = imagecreatetruecolor($nw, $nh);
		imagecopyresampled($nimg, $img, 0, 0, 0, 0, $nw, $nh, $w, $h);
		if(!@unlink($file))
		{
			return;
		}
		if($type == 1)
		{
			imagegif($nimg, $file);
		} elseif ($type == 2)
		{
			imagejpeg($nimg, $file, 85);
		} elseif ($type == 3)
		{
			imagepng($nimg, $file, 85);
		}
		imagedestroy($img);
		imagedestroy($nimg);
	}
?>